import 'dart:async';
import 'package:flutter/material.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xfxbase/_XFX/XF_View.dart';
import 'package:xfxwidgets/XF_MAIN/XAppState.dart';
import 'package:xtoolspackage/xtoolspackage.dart';
import 'XElenco.dart';

class ElXBase_ElencoDraggable<T> extends XElenco<ElXBase_ElencoDraggable<T>, XFDataItem> {
  ElXBase_ElencoDraggable(
    this.viewToUse,
    this.title, {
    this.xFilter_SearchBarXCols,
    this.xActions_Left,
    this.itemWidget,
    this.itemWidget_FeedBack,
    this.itemWidget_WhenDragging,
    Key? key,
    super.liXMediaToUse,
    Widget? xDrawerMenu,
    this.liToUse,
    super.xApp,
    Function(T)? functToDelete,
    super.rootItemEdited,
    super.itemEdited,
    super.onTapItem,
    super.xBL_BTN_EmptyList,
    super.xCells_Item_Width,
    super.xCells_Item_Widget,
    super.xCells_Item_TextStyle,
  }) : super(
          title,
          viewToUse,
          pageMode_Active: true,
          liDetts: liToUse,
          onLongTapItem: functToDelete != null ? (item) => functToDelete(item) : null,
          xDrawerMenu: xDrawerMenu,
          key: key,
          title_Style: XStyles.xStyTextForTitle(textColor: XColors.foregroundLight),
          title_Color: (XColors.foregroundLight),
        );
  List<T>? liToUse;
  Function(T)? functToDelete;
  XView viewToUse;
  String title;
  List<XProp>? xFilter_SearchBarXCols;
  List<XAction>? xActions_Left;
  Widget? Function(XFDataItem)? itemWidget;
  Widget? Function(XFDataItem)? itemWidget_FeedBack;
  Widget? Function(XFDataItem)? itemWidget_WhenDragging;
  @override
  ElXBase_ElencoDraggable_State<T> createState() => ElXBase_ElencoDraggable_State<T>();
}

class ElXBase_ElencoDraggable_State<T> extends XElencoState<ElXBase_ElencoDraggable<T>, XFDataItem> {}

class ElencoDraggable<T> extends ElXBase_ElencoDraggable<T> {
  ElencoDraggable(
    this.obj,
    this.title,
    this.viewToUse, {
    this.xFilter_SearchBarXCols,
    this.xActions_Left,
    this.itemWidget,
    this.itemWidget_FeedBack,
    this.itemWidget_WhenDragging,
    this.isSch = false,
    super.liXMediaToUse,
    super.xApp,
    super.liToUse,
    super.functToDelete,
    super.onTapItem,
    super.xBL_BTN_EmptyList,
    super.rootItemEdited,
    super.itemEdited,
    super.xCells_Item_Width,
    super.xCells_Item_Widget,
    super.xCells_Item_TextStyle,
  }) : super(viewToUse, title);
  T? obj;
  bool? isSch;
  XView viewToUse;
  String title;
  List<XProp>? xFilter_SearchBarXCols;
  List<XAction>? xActions_Left;
  Widget? Function(XFDataItem)? itemWidget;
  Widget? Function(XFDataItem)? itemWidget_FeedBack;
  Widget? Function(XFDataItem)? itemWidget_WhenDragging;
  List<Widget>? xActionsAppBar_Widgets;
  @override
  _El_ElencoDraggable_State<T> createState() => _El_ElencoDraggable_State<T>();
}

class _El_ElencoDraggable_State<T> extends ElXBase_ElencoDraggable_State<T> {
  late AnimationController _controller;
  @override
  void initState() {
    widget.view = (widget as ElXBase_ElencoDraggable).viewToUse;
    widget.schedaMode = (widget as ElencoDraggable).isSch;
    widget.xApp = (widget as ElXBase_ElencoDraggable).xApp;
    widget.allowAdd = true;
    widget.appBar_Height = 40;
    widget.title_Text = (widget as ElXBase_ElencoDraggable).title;
    super.initState();
    xActionLi_LEFT!.addAll((widget as ElXBase_ElencoDraggable).xActions_Left ?? []);
    widget.onLongTapItem = (p0) async => await widget.onLongTapItem!(p0);
    widget.onTapBack = () => Navigator.pop(context);
    _controller = AnimationController(
      vsync: this,
      duration: Duration(milliseconds: 300),
    )..repeat(reverse: true); // Ripete l'animazione all'indietro dopo che è completata
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  void initXFilters() {
    super.initXFilters();
    xFilter_SearchBarXCols.addAll((widget as ElXBase_ElencoDraggable).xFilter_SearchBarXCols ?? []);
  }

  _buildMainWidget(double width_UI, XFDataItem xItem) {
    return Container(
        width: width_UI,
        child: (widget as ElXBase_ElencoDraggable).itemWidget != null
            ? ((widget as ElXBase_ElencoDraggable).itemWidget!(xItem) ?? Container()) //
            : (super.xLayout_ItemWidget(xItem) ?? Container()));
  }

  _buildMainWidget_FeedBack(double width_UI, XFDataItem xItem) {
    return Container(
        width: width_UI,
        child: (widget as ElXBase_ElencoDraggable).itemWidget_FeedBack != null
            ? ((widget as ElXBase_ElencoDraggable).itemWidget_FeedBack!(xItem) ?? Container()) //
            : (super.xLayout_ItemWidget(xItem) ?? Container()));
  }

  _buildMainWidget_WhenDragging(double width_UI, XFDataItem xItem) {
    return Container(
        width: width_UI,
        child: (widget as ElXBase_ElencoDraggable).itemWidget_WhenDragging != null
            ? ((widget as ElXBase_ElencoDraggable).itemWidget_WhenDragging!(xItem) ?? Container()) //
            : (super.xLayout_ItemWidget(xItem) ?? Container()));
  }

  @override
  Widget? xLayout_ItemWidget(XFDataItem xItem) {
    var width_UI = MediaQuery.of(context).size.width - 10;
    var w = LongPressDraggable<XFDataItem>(
      data: xItem,
      onDragStarted: () {
        xItem.isSel = true;
        Timer(Duration(seconds: 2), () {
          xItem.isSel = false;
        });
      },
      onDragEnd: (details) {
        xItem.isSel = false;
      },
      child: AnimatedBuilder(
          animation: _controller,
          builder: (context, child) {
            return xItem.isSel
                ? Transform.translate(
                    offset: Offset(10 * _controller.value, 0), // Valore di traslazione basato sull'animazione
                    child: _buildMainWidget(width_UI, xItem))
                : _buildMainWidget(width_UI, xItem);
          }),
      feedback: AnimatedBuilder(
          animation: _controller,
          builder: (context, child) {
            return xItem.isSel
                ? Transform.translate(
                    offset: Offset(10 * _controller.value, 0), // Valore di traslazione basato sull'animazione
                    child: _buildMainWidget_FeedBack(width_UI, xItem))
                : _buildMainWidget_FeedBack(width_UI, xItem);
          }),
      childWhenDragging: AnimatedBuilder(
          animation: _controller,
          builder: (context, child) {
            return xItem.isSel
                ? Transform.translate(
                    offset: Offset(10 * _controller.value, 0), // Valore di traslazione basato sull'animazione
                    child: _buildMainWidget_WhenDragging(width_UI, xItem))
                : _buildMainWidget_WhenDragging(width_UI, xItem);
          }),
    );
    return w;
  }
}
