import 'package:flutter/material.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/XFDataItem.dart';
import 'package:xtoolspackage/xtoolspackage.dart';

class XFilterEl<T> {
  XFilterEl(this.xPropOfItemToFilter, {this.All, this.backgroundMenuColor, this.width, this.menu_height, this.textStyle}) {
    this.Value = this.All;
  }
  List<T> Items = List<T>.empty(growable: true);
  // late T Current;
  T? All;
  T? Value;
  late XProp xPropOfItemToFilter;
  List<XProp> ColsOfXFdataItemToShow = List<XProp>.empty(growable: true);
  Color? backgroundMenuColor;
  double? width;
  double? menu_height;
  TextStyle? Function(dynamic)? textStyle;
  static XFilterEl<XEnumDef> fromXEnumDefs(XProp xPropOfItemToFilter, XEnum xEnum, {String all_label = "TUTTI", int all_value = -1, dynamic initialValue, Color? backgroundMenuColor, double? width, double? menu_height, TextStyle? Function(XEnumDef)? textStyle}) {
    var xf = XFilterEl<XEnumDef>(
      xPropOfItemToFilter,
      All: (all_value < 0 ? null : XEnumDef(label: all_label, value: all_value, backColor: XColors.backgroundDark, textColor: XColors.foregroundLight)),
      backgroundMenuColor: backgroundMenuColor,
      width: width,
      menu_height: menu_height,
      textStyle: textStyle != null ? (p0) => textStyle(p0) : null,
    );
    xf.Items = xEnum.definitions.values.toList();
    if (initialValue != null) {
      xf.Value = initialValue;
    }
    return xf;
  }

  static XFilterEl from<T>(XProp xPropOfItemToFilter, List<T> items, {T? All, dynamic initialValue, Color? backgroundMenuColor, double? width, double? menu_height, TextStyle? Function(dynamic)? textStyle}) {
    var xf = XFilterEl<T>(
      xPropOfItemToFilter,
      All: All,
      backgroundMenuColor: backgroundMenuColor,
      width: width,
      menu_height: menu_height,
      textStyle: textStyle != null ? (p0) => textStyle(p0) : null,
    );
    xf.Items = items;
    if (initialValue != null) {
      xf.Value = initialValue;
    }
    return xf;
  }
}
